#ifndef __MANDOWINDOW_HH
#define __MANDOWINDOW_HH

#include <boost/numeric/ublas/vector.hpp>
#include "image_v4linput.h"
#include <QtGui/QWidget>
#include "clickEstimator.hh"
#include "pointerRecognition.hh"
#include "ui_mandoWindow.hh"
#include <X11/Xlib.h>

class MandoWizard;

class MandoWindow: public QWidget
{
  Q_OBJECT
public:
  typedef mimas::image_v4linput< mimas::rgba< unsigned char > > Video;
  typedef boost::shared_ptr< Video > VideoPtr;
  typedef boost::numeric::ublas::vector< double > Vector;
  MandoWindow( QWidget *parent = 0, Qt::WFlags = 0 );
protected slots:
  void about();
  void configure();
  void activate(bool);
  void startDrag();
  void stopDrag();
  void click();
  void mouseMove(int,int);
protected:
  mimas::image< mimas::rgba< unsigned char > > grabColourFrame(void)
    throw (mimas ::mimasexception);
  virtual void timerEvent( QTimerEvent *e );
  Ui::MandoWindow ui;
  MandoWizard *mandoWizard;
  int timer;
  ClickEstimator *clickEstimator;
  PointerRecognitionPtr pointerRecognition;
  VideoPtr input;
};

#endif
